---
stages:
  - build

default:
  image: docker:stable
  services:
    - name: registry.hub.docker.com/library/docker:dind
      alias: docker
  before_script:
    - echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER --password-stdin $CI_REGISTRY
    - echo $NVRC_API_KEY | docker login -u \$oauthtoken --password-stdin nvcr.io 2>/dev/null || true

variables:
  DOCKER_TLS_CERTDIR: "/certs"
  DOCKER_BUILDKIT: 1

build:
  stage: build
  timeout: 4 hours
  script:
    - docker build -f Containerfile.cpu -t $CI_REGISTRY_IMAGE:latest-cpu .
    - docker tag $CI_REGISTRY_IMAGE:latest-cpu $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:latest-cpu
    - docker push $CI_REGISTRY_IMAGE:latest
    - docker build -f Containerfile.cuda -t $CI_REGISTRY_IMAGE:latest-cuda .
    - docker push $CI_REGISTRY_IMAGE:latest-cuda
    - >
      docker build -f Containerfile.py.x.cuda --build-arg PY_VERSION=3.11 \
        -t $CI_REGISTRY_IMAGE:latest-py3.11-cuda .
    - docker push $CI_REGISTRY_IMAGE:latest-py3.11-cuda
    - >
      docker build -f Containerfile.py.x.cuda \
        --build-arg BASE_IMAGE=nvcr.io/nvidia/cuda:12.3.0-devel-ubuntu22.04 \
        -t $CI_REGISTRY_IMAGE:latest-py3.11-cuda12.3.0 .
    - docker push $CI_REGISTRY_IMAGE:latest-py3.11-cuda12.3.0
    - docker build -f Containerfile.jetson -t $CI_REGISTRY_IMAGE:latest-jetson .
    - docker push $CI_REGISTRY_IMAGE:latest-jetson
